	/*524:*/
	#line 10991 "format.w"

#include "basetypes.h"
#include <string.h>
#include <zlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "error.h"
#include "format.h"
	/*1:*/
	#line 329 "format.w"

typedef struct{uint32_t c;uint8_t f;}Glyph;
	/*:1*/	/*113:*/
	#line 2167 "format.w"

typedef struct{
Dimen h,d,w;
}Rule;
	/*:113*/	/*122:*/
	#line 2281 "format.w"

typedef struct{
bool x;
Xdimen d;
}Kern;
	/*:122*/	/*140:*/
	#line 2702 "format.w"

typedef struct{
Kind k;
uint32_t p;
uint32_t s;
}List;
	/*:140*/	/*148:*/
	#line 3124 "format.w"

typedef enum{txt_font= 0x00,txt_global= 0x08,txt_local= 0x11,
txt_cc= 0x1D,txt_node= 0x1E,txt_hyphen= 0x1F,
txt_glue= 0x20,txt_ignore= 0xFB}Txt;
	/*:148*/	/*159:*/
	#line 3391 "format.w"

typedef struct{Kind k;int n;}Ref;
	/*:159*/	/*160:*/
	#line 3428 "format.w"

typedef struct{Dimen h,d,w,a;float32_t r;int8_t s,o;List l;}Box;
	/*:160*/	/*187:*/
	#line 3984 "format.w"

typedef struct{uint8_t f;List l;}Lig;
	/*:187*/	/*195:*/
	#line 4101 "format.w"

typedef struct{bool x;List p,q;uint8_t r;}Disc;
	/*:195*/	/*228:*/
	#line 4659 "format.w"

typedef struct{
uint16_t n;
float32_t a;
Xdimen w,h;
uint8_t wr,hr;
}Image;
	/*:228*/	/*272:*/
	#line 5687 "format.w"

typedef struct{
uint8_t*t;
int s;
int d;
uint16_t r;
}Outline;
	/*:272*/	/*299:*/
	#line 6503 "format.w"

typedef
struct{uint8_t pg;uint32_t pos;bool on;int link;}RangePos;
	/*:299*/
	#line 11000 "format.w"


	/*252:*/
	#line 5345 "format.w"

Label*labels= NULL;
int first_label= -1;
	/*:252*/	/*300:*/
	#line 6508 "format.w"

RangePos*range_pos;
int next_range= 1,max_range;
int*page_on;
	/*:300*/	/*311:*/
	#line 6692 "format.w"

char hbanner[MAX_BANNER+1];
int hbanner_size= 0;
	/*:311*/	/*318:*/
	#line 6835 "format.w"

uint8_t*hpos= NULL,*hstart= NULL,*hend= NULL,*hpos0= NULL;
	/*:318*/	/*324:*/
	#line 6916 "format.w"

char*hin_name= NULL;
uint64_t hin_size= 0;
uint8_t*hin_addr= NULL;
uint64_t hin_time= 0;
	/*:324*/	/*380:*/
	#line 8388 "format.w"

char**hfont_name;
	/*:380*/	/*419:*/
	#line 9088 "format.w"

unsigned int debugflags= DBGNONE;
int option_utf8= false;
int option_hex= false;
int option_force= false;
int option_global= false;
int option_aux= false;
int option_compress= false;
char*stem_name= NULL;
int stem_length= 0;
	/*:419*/	/*422:*/
	#line 9222 "format.w"

FILE*hin= NULL,*hout= NULL,*hlog= NULL;
	/*:422*/
	#line 11002 "format.w"


	/*325:*/
	#line 6923 "format.w"

#ifndef USE_MMAP
void hget_unmap(void)
{if(hin_addr!=NULL)free(hin_addr);
hin_addr= NULL;
hin_size= 0;
}
bool hget_map(void)
{FILE*f;
struct stat st;
size_t s,t;
uint64_t u;
f= fopen(hin_name,"rb");
if(f==NULL)
{MESSAGE("Unable to open file: %s\n",hin_name);return false;}
if(stat(hin_name,&st)<0)
{MESSAGE("Unable to obtain file size: %s\n",hin_name);
fclose(f);
return false;
}
if(st.st_size==0)
{MESSAGE("File %s is empty\n",hin_name);
fclose(f);
return false;
}
u= st.st_size;
if(hin_addr!=NULL)hget_unmap();
hin_addr= malloc(u);
if(hin_addr==NULL)
{MESSAGE("Unable to allocate 0x%"PRIx64" byte for File %s\n",u,hin_name);
fclose(f);
return 0;
}
t= 0;
do{
s= fread(hin_addr+t,1,u,f);
if(s<=0)
{MESSAGE("Unable to read file %s\n",hin_name);
fclose(f);
free(hin_addr);
hin_addr= NULL;
return false;
}
t= t+s;
u= u-s;
}while(u>0);
hin_size= st.st_size;
hin_time= st.st_mtime;
return true;
}

#else

#include <sys/mman.h>

void hget_unmap(void)
{munmap(hin_addr,hin_size);
hin_addr= NULL;
hin_size= 0;
}

bool hget_map(void)
{struct stat st;
int fd;
fd= open(hin_name,O_RDONLY,0);
if(fd<0)
{MESSAGE("Unable to open file %s\n",hin_name);return false;}
if(fstat(fd,&st)<0)
{MESSAGE("Unable to get file size\n");
close(fd);
return false;
}
if(st.st_size==0)
{MESSAGE("File %s is empty\n",hin_name);
close(fd);
return false;
}
if(hin_addr!=NULL)hget_unmap();
hin_size= st.st_size;
hin_time= st.st_mtime;
hin_addr= mmap(NULL,hin_size,PROT_READ,MAP_PRIVATE,fd,0);
if(hin_addr==MAP_FAILED)
{close(fd);
hin_addr= NULL;hin_size= 0;
MESSAGE("Unable to map file into memory\n");
return 0;
}
close(fd);
return hin_size;
}
#endif

	/*:325*/
	#line 11004 "format.w"

	/*312:*/
	#line 6697 "format.w"


bool hcheck_banner(char*magic)
{
int v;
char*t;
t= hbanner;
if(strncmp(magic,hbanner,4)!=0)
{MESSAGE("This is not a %s file\n",magic);return false;}
else t+= 4;
if(hbanner[hbanner_size-1]!='\n')
{MESSAGE("Banner exceeds maximum size=0x%x\n",MAX_BANNER);return false;}
if(*t!=' ')
{MESSAGE("Space expected in banner after %s\n",magic);return false;}
else t++;
v= strtol(t,&t,10);
if(v!=HINT_VERSION)
{MESSAGE("Wrong HINT version: got %d, expected %d\n",v,HINT_VERSION);return false;}
if(*t!='.')
{MESSAGE("Dot expected in banner after HINT version number\n");return false;}
else t++;
v= strtol(t,&t,10);
if(v!=HINT_SUB_VERSION)
{MESSAGE("Wrong HINT subversion: got %d, expected %d\n",v,HINT_SUB_VERSION);return false;}
if(*t!=' '&&*t!='\n')
{MESSAGE("Space expected in banner after HINT subversion\n");return false;}
LOG("%s file version "HINT_VERSION_STRING":%s",magic,t);
DBG(DBGDIR,"banner size=0x%x\n",hbanner_size);
return true;
}
	/*:312*/
	#line 11005 "format.w"

	/*333:*/
	#line 7242 "format.w"

typedef struct{
uint64_t pos;
uint32_t size,xsize;
uint16_t section_no;
char*file_name;
uint8_t*buffer;
uint32_t bsize;
}Entry;
	/*:333*/
	#line 11006 "format.w"

	/*334:*/
	#line 7256 "format.w"

Entry*dir= NULL;
uint16_t section_no,max_section_no;
void new_directory(uint32_t entries)
{DBG(DBGDIR,"Creating directory with %d entries\n",entries);
RNG("Directory entries",entries,3,0x10000);
max_section_no= entries-1;
ALLOCATE(dir,entries,Entry);
dir[0].section_no= 0;dir[1].section_no= 1;dir[2].section_no= 2;
}
	/*:334*/	/*335:*/
	#line 7269 "format.w"

void hset_entry(Entry*e,uint16_t i,uint32_t size,uint32_t xsize,char*file_name)
{e->section_no= i;
e->size= size;e->xsize= xsize;
if(file_name==NULL||*file_name==0)
e->file_name= NULL;
else
e->file_name= strdup(file_name);
DBG(DBGDIR,"Creating entry %d: \"%s\" size=0x%x xsize=0x%x\n",i,file_name,size,xsize);
}
	/*:335*/
	#line 11007 "format.w"

	/*37:*/
	#line 1068 "format.w"

#define HGET_STRING(S) S= (char*)hpos;\
 while(hpos<hend && *hpos!=0) { RNG("String character",*hpos,0x20,0x7E); hpos++;}\
 hpos++;
	/*:37*/	/*146:*/
	#line 2871 "format.w"

#define HGET_LIST(I,L) \
    (L).s= hget_list_size(I); hget_size_boundary(I);\
    (L).p= hpos-hstart; \
    hpos= hpos+(L).s; hget_size_boundary(I);\
    { uint32_t s= hget_list_size(I); \
      if (s!=(L).s) \
      QUIT("List sizes at 0x%x and " SIZE_F " do not match 0x%x != 0x%x",node_pos+1,hpos-hstart-I-1,(L).s,s);}
	/*:146*/	/*319:*/
	#line 6843 "format.w"

#define HGET_ERROR  QUIT("HGET overrun in section %d at " SIZE_F "\n",section_no,hpos-hstart)
#define HEND   ((hpos<=hend)?0:(HGET_ERROR,0))

#define HGET8      ((hpos<hend)?*(hpos++):(HGET_ERROR,0))
#define HGET16(X) ((X)= (hpos[0]<<8)+hpos[1],hpos+= 2,HEND)
#define HGET24(X) ((X)= (hpos[0]<<16)+(hpos[1]<<8)+hpos[2],hpos+= 3,HEND)
#define HGET32(X) ((X)= (hpos[0]<<24)+(hpos[1]<<16)+(hpos[2]<<8)+hpos[3],hpos+= 4,HEND)
#define HGETTAG(A) A= HGET8,DBGTAG(A,hpos-1)
	/*:319*/	/*344:*/
	#line 7470 "format.w"

#define HGET_SIZE(I) \
  if ((I)&b100) { \
    if (((I)&b011)==0) s= HGET8,xs= HGET8; \
    else if (((I)&b011)==1) HGET16(s),HGET16(xs); \
    else if (((I)&b011)==2) HGET24(s),HGET24(xs); \
    else if (((I)&b011)==3) HGET32(s),HGET32(xs); \
   } \
  else { \
    if (((I)&b011)==0) s= HGET8; \
    else if (((I)&b011)==1) HGET16(s); \
    else if (((I)&b011)==2) HGET24(s); \
    else if (((I)&b011)==3) HGET32(s); \
   }

#define HGET_ENTRY(I,E) \
{ uint16_t i; \
  uint32_t s= 0,xs= 0; \
  char *file_name; \
  HGET16(i); HGET_SIZE(I); HGET_STRING(file_name); \
  hset_entry(&(E),i,s,xs,file_name); \
}
	/*:344*/	/*464:*/
	#line 9836 "format.w"

#define HBACK(X) ((hpos-(X)<hstart)?(QUIT("HTEG underflow\n"),NULL):(hpos-= (X)))

#define HTEG8     (HBACK(1),hpos[0])
#define HTEG16(X) (HBACK(2),(X)= (hpos[0]<<8)+hpos[1])
#define HTEG24(X) (HBACK(3),(X)= (hpos[0]<<16)+(hpos[1]<<8)+hpos[2])
#define HTEG32(X) (HBACK(4),(X)= (hpos[0]<<24)+(hpos[1]<<16)+(hpos[2]<<8)+hpos[3])
#define HTEGTAG(X) X= HTEG8,DBGTAG(X,hpos)
	/*:464*/
	#line 11008 "format.w"

	/*313:*/
	#line 6736 "format.w"

void hget_banner(void)
{hbanner_size= 0;
while(hbanner_size<MAX_BANNER&&hpos<hend)
{uint8_t c= HGET8;
hbanner[hbanner_size++]= c;
if(c=='\n')break;
}
hbanner[hbanner_size]= 0;
}
	/*:313*/	/*326:*/
	#line 7028 "format.w"


static void hdecompress(uint16_t n)
{z_stream z;
uint8_t*buffer;
int i;

DBG(DBGCOMPRESS,"Decompressing section %d from 0x%x to 0x%x byte\n",n,dir[n].size,dir[n].xsize);
z.zalloc= (alloc_func)0;
z.zfree= (free_func)0;
z.opaque= (voidpf)0;
z.next_in= hstart;
z.avail_in= hend-hstart;
if(inflateInit(&z)!=Z_OK)
QUIT("Unable to initialize decompression: %s",z.msg);
ALLOCATE(buffer,dir[n].xsize+MAX_TAG_DISTANCE,uint8_t);
DBG(DBGBUFFER,"Allocating output buffer size=0x%x, margin=0x%x\n",dir[n].xsize,MAX_TAG_DISTANCE);
z.next_out= buffer;
z.avail_out= dir[n].xsize+MAX_TAG_DISTANCE;
i= inflate(&z,Z_FINISH);
DBG(DBGCOMPRESS,"in: avail/total=0x%x/0x%lx ""out: avail/total=0x%x/0x%lx, return %d;\n",
z.avail_in,z.total_in,z.avail_out,z.total_out,i);
if(i!=Z_STREAM_END)
QUIT("Unable to complete decompression: %s",z.msg);
if(z.avail_in!=0)
QUIT("Decompression missed input data");
if(z.total_out!=dir[n].xsize)
QUIT("Decompression output size mismatch 0x%lx != 0x%x",z.total_out,dir[n].xsize);
if(inflateEnd(&z)!=Z_OK)
QUIT("Unable to finalize decompression: %s",z.msg);
dir[n].buffer= buffer;
dir[n].bsize= dir[n].xsize;
hpos0= hpos= hstart= buffer;
hend= hstart+dir[n].xsize;
}
	/*:326*/	/*328:*/
	#line 7116 "format.w"

void hget_section(uint16_t n)
{DBG(DBGDIR,"Reading section %d\n",n);
RNG("Section number",n,0,max_section_no);
if(dir[n].buffer!=NULL&&dir[n].xsize>0)
{hpos0= hpos= hstart= dir[n].buffer;
hend= hstart+dir[n].xsize;
}
else
{hpos0= hpos= hstart= hin_addr+dir[n].pos;
hend= hstart+dir[n].size;
if(dir[n].xsize>0)hdecompress(n);
}
}
	/*:328*/	/*345:*/
	#line 7494 "format.w"

void hget_entry(Entry*e)
{	/*15:*/
	#line 718 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos>=hend)QUIT("Attempt to read a start byte at the end of the section");
HGETTAG(a);
	/*:15*/
	#line 7496 "format.w"

DBG(DBGDIR,"Reading directory entry\n");
switch(a)
{case TAG(0,b000+0):HGET_ENTRY(b000+0,*e);break;
case TAG(0,b000+1):HGET_ENTRY(b000+1,*e);break;
case TAG(0,b000+2):HGET_ENTRY(b000+2,*e);break;
case TAG(0,b000+3):HGET_ENTRY(b000+3,*e);break;
case TAG(0,b100+0):HGET_ENTRY(b100+0,*e);break;
case TAG(0,b100+1):HGET_ENTRY(b100+1,*e);break;
case TAG(0,b100+2):HGET_ENTRY(b100+2,*e);break;
case TAG(0,b100+3):HGET_ENTRY(b100+3,*e);break;
default:TAGERR(a);break;
}
	/*16:*/
	#line 725 "format.w"

HGETTAG(z);
if(a!=z)
QUIT("Tag mismatch [%s,%d]!=[%s,%d] at 0x%x to "SIZE_F"\n",
NAME(a),INFO(a),NAME(z),INFO(z),node_pos,hpos-hstart-1);
	/*:16*/
	#line 7509 "format.w"

}
	/*:345*/	/*346:*/
	#line 7526 "format.w"

static void hget_root(Entry*root)
{DBG(DBGDIR,"Root entry at "SIZE_F"\n",hpos-hstart);
hget_entry(root);
root->pos= hpos-hstart;
max_section_no= root->section_no;
root->section_no= 0;
if(max_section_no<2)QUIT("Sections 0, 1, and 2 are mandatory");
}

void hget_directory(void)
{int i;
Entry root= {0};
hget_root(&root);
DBG(DBGDIR,"Directory\n");
new_directory(max_section_no+1);
dir[0]= root;
DBG(DBGDIR,"Directory entry 1 at 0x%"PRIx64"\n",dir[0].pos);
hget_section(0);
for(i= 1;i<=max_section_no;i++)
{hget_entry(&(dir[i]));
dir[i].pos= dir[i-1].pos+dir[i-1].size;
DBG(DBGDIR,"Section %d at 0x%"PRIx64"\n",i,dir[i].pos);
}
}

void hclear_dir(void)
{int i;
if(dir==NULL)return;
for(i= 0;i<3;i++)
if(dir[i].xsize>0&&dir[i].buffer!=NULL)free(dir[i].buffer);
free(dir);dir= NULL;
}

	/*:346*/	/*364:*/
	#line 7950 "format.w"

void hget_max_definitions(void)
{Kind k;
	/*15:*/
	#line 718 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos>=hend)QUIT("Attempt to read a start byte at the end of the section");
HGETTAG(a);
	/*:15*/
	#line 7953 "format.w"

if(a!=TAG(list_kind,0))QUIT("Start of maximum list expected");
for(k= 0;k<32;k++)max_ref[k]= max_default[k];max_outline= -1;
while(true)
{int n;
if(hpos>=hend)QUIT("Unexpected end of maximum list");
node_pos= hpos-hstart;
HGETTAG(a);
k= KIND(a);
if(k==list_kind)break;
if(INFO(a)&b001)HGET16(n);else n= HGET8;
switch(a)
{	/*246:*/
	#line 5275 "format.w"


case TAG(outline_kind,b100):
case TAG(outline_kind,b101):max_outline= n;
DBG(DBGDEF|DBGLABEL,"max(outline) = %d\n",max_outline);break;
	/*:246*/
	#line 7965 "format.w"

default:
if(max_fixed[k]>max_default[k])
QUIT("Maximum value for kind %s not supported",definition_name[k]);
RNG("Maximum number",n,max_default[k],MAX_REF(k));
max_ref[k]= n;
DBG(DBGDEF,"max(%s) = %d\n",definition_name[k],max_ref[k]);
break;
}
	/*16:*/
	#line 725 "format.w"

HGETTAG(z);
if(a!=z)
QUIT("Tag mismatch [%s,%d]!=[%s,%d] at 0x%x to "SIZE_F"\n",
NAME(a),INFO(a),NAME(z),INFO(z),node_pos,hpos-hstart-1);
	/*:16*/
	#line 7974 "format.w"

}
if(INFO(a)!=0)QUIT("End of maximum list with info %d",INFO(a));
}
	/*:364*/
	#line 11009 "format.w"


	/*440:*/
	#line 9489 "format.w"

#define I_T(I,T) (((-(I))<<2)|((T)-1))
	/*:440*/	/*466:*/
	#line 9860 "format.w"

#define HTEG_XDIMEN(I,X) \
  if((I)&b001) HTEG32((X).v); \
  if((I)&b010) HTEG32((X).h);\
  if((I)&b100) HTEG32((X).w);
	/*:466*/	/*468:*/
	#line 9894 "format.w"

#define HTEG_STRETCH(S) { Stch st;  HTEG32(st.u); S.o= st.u&3;  st.u&= ~3; S.f= st.f; }
	/*:468*/	/*469:*/
	#line 9900 "format.w"

#define HTEG_GLYPH(I,G) \
  (G).f= HTEG8; \
  if (I==1) (G).c= HTEG8;\
  else if (I==2) HTEG16((G).c);\
  else if (I==3) HTEG24((G).c);\
  else if (I==4) HTEG32((G).c);
	/*:469*/	/*471:*/
	#line 9919 "format.w"

#define HTEG_PENALTY(I,P) \
if (I==1) {int8_t n; n= HTEG8;  P= n; } \
else {int16_t n; HTEG16(n);  P= n; }\
	/*:471*/	/*473:*/
	#line 9933 "format.w"

#define HTEG_KERN(I,X) if (((I)&b011)==2) HTEG32(X.w); else if (((I)&b011)==3)  hteg_xdimen_node(&(X))
	/*:473*/	/*476:*/
	#line 9958 "format.w"

#define HTEG_RULE(I,R)\
if ((I)&b001) HTEG32((R).w); else (R).w= RUNNING_DIMEN;\
if ((I)&b010) HTEG32((R).d); else (R).d= RUNNING_DIMEN;\
if ((I)&b100) HTEG32((R).h); else (R).h= RUNNING_DIMEN;
	/*:476*/	/*479:*/
	#line 9984 "format.w"

#define HTEG_GLUE(I,G) \
  if(I==b111) hteg_xdimen_node(&((G).w)); else (G).w.h= (G).w.v= 0.0;\
  if((I)&b001) HTEG_STRETCH((G).m) else  (G).m.f= 0.0, (G).m.o= 0; \
  if((I)&b010) HTEG_STRETCH((G).p) else (G).p.f= 0.0, (G).p.o= 0;\
  if((I)!=b111) { if ((I)&b100) HTEG32((G).w.w); else (G).w.w= 0; }
	/*:479*/	/*482:*/
	#line 10014 "format.w"

#define HTEG_BOX(I,B) \
hteg_list(&(B.l));\
if ((I)&b100) { B.s= HTEG8;  B.r= hteg_float32();  B.o= B.s&0xF; B.s= B.s>>4; }\
else {  B.r= 0.0; B.o= B.s= 0; }\
if ((I)&b010) HTEG32(B.a); else B.a= 0;\
HTEG32(B.w);\
if ((I)&b001) HTEG32(B.d);  else B.d= 0;\
HTEG32(B.h);\
	/*:482*/	/*485:*/
	#line 10065 "format.w"

#define HTEG_SET(I) \
{ List l; hteg_list(&l); } \
 if ((I)&b100) {Xdimen x; hteg_xdimen_node(&x); } \
 else HTEG_REF(xdimen_kind);\
{ Stretch m; HTEG_STRETCH(m);}\
{ Stretch p; HTEG_STRETCH(p);}\
if ((I)&b010)  { Dimen a; HTEG32(a);} \
 { Dimen w; HTEG32(w);} \
 { Dimen d; if ((I)&b001) HTEG32(d);  else d= 0;}\
 { Dimen h; HTEG32(h);}


#define HTEG_PACK(K,I) \
 { List l; hteg_list(&l); } \
 if ((I)&b100) {Xdimen x; hteg_xdimen_node(&x);}  else HTEG_REF(xdimen_kind);\
 if (K==vpack_kind) { Dimen d; HTEG32(d);  }\
 if ((I)&b010)  { Dimen d; HTEG32(d);  }
	/*:485*/	/*487:*/
	#line 10126 "format.w"

#define HTEG_LEADERS(I) \
if (KIND(hpos[-1])==rule_kind) hteg_rule_node(); \
else if (KIND(hpos[-1])==hbox_kind)  hteg_hbox_node();\
else  hteg_vbox_node();\
if ((I)&b100) hteg_glue_node();
	/*:487*/	/*489:*/
	#line 10145 "format.w"

#define HTEG_BASELINE(I,B) \
  if((I)&b010) hteg_glue_node(); \
  else {B.ls.p.o= B.ls.m.o= B.ls.w.w= 0; B.ls.w.h= B.ls.w.v= B.ls.p.f= B.ls.m.f= 0.0;}\
  if((I)&b100) hteg_glue_node(); \
  else {B.bs.p.o= B.bs.m.o= B.bs.w.w= 0; B.bs.w.h= B.bs.w.v= B.bs.p.f= B.bs.m.f= 0.0;}\
  if((I)&b001) HTEG32((B).lsl); else B.lsl= 0;
	/*:489*/	/*491:*/
	#line 10165 "format.w"

#define HTEG_LIG(I,L) \
if ((I)==7) hteg_list(&((L).l)); \
else {(L).l.s= (I); hpos-= (L).l.s;  (L).l.p= hpos-hstart;} \
(L).f= HTEG8;
	/*:491*/	/*493:*/
	#line 10185 "format.w"

#define HTEG_DISC(I,H)\
if ((I)&b001) hteg_list(&((H).q)); else { (H).q.p= hpos-hstart; (H).q.s= 0; (H).q.k= list_kind; }\
if ((I)&b010) hteg_list(&((H).p)); else { (H).p.p= hpos-hstart; (H).p.s= 0; (H).p.k= list_kind; } \
if ((I)&b100) (H).r= HTEG8; else (H).r= 0;
	/*:493*/	/*495:*/
	#line 10204 "format.w"

#define HTEG_PAR(I) \
 { List l; hteg_list(&l); } \
 if ((I)&b010) { List l; hteg_param_list(&l); }  else if ((I)!=b100) HTEG_REF(param_kind);\
 if ((I)&b100)  {Xdimen x;  hteg_xdimen_node(&x); }  else HTEG_REF(xdimen_kind);\
 if ((I)==b100) HTEG_REF(param_kind);
	/*:495*/	/*497:*/
	#line 10222 "format.w"

#define HTEG_MATH(I) \
if ((I)&b001) hteg_hbox_node();\
{ List l; hteg_list(&l); } \
if ((I)&b010) hteg_hbox_node(); \
if ((I)&b100) { List l; hteg_param_list(&l); }  else HTEG_REF(param_kind);
	/*:497*/	/*499:*/
	#line 10243 "format.w"

#define HTEG_IMAGE(I) \
{ Image x= {0}; List d; hteg_list(&d);\
if ((I)&b100) {\
 if ((I)==b111) {hteg_xdimen_node(&x.h);hteg_xdimen_node(&x.w);}\
 else if ((I)==b110) {hteg_xdimen_node(&x.w);x.hr= HTEG8;}\
 else if ((I)==b101) {hteg_xdimen_node(&x.h);x.wr= HTEG8;}\
 else  {x.hr= HTEG8;x.wr= HTEG8;}\
x.a= hteg_float32();}\
else if((I)==b011) {HTEG32(x.h.w);HTEG32(x.w.w);} \
else if((I)==b010) { HTEG32(x.w.w); x.a= hteg_float32();}\
else if((I)==b001){ HTEG32(x.h.w); x.a= hteg_float32();}\
HTEG16(x.n);}
	/*:499*/	/*501:*/
	#line 10271 "format.w"

#define HTEG_LINK(I) \
{ uint16_t n; if (I&b001) HTEG16(n); else n= HTEG8; }
	/*:501*/	/*505:*/
	#line 10342 "format.w"

#define HTEG_TABLE(I) \
{ List l;  hteg_list(&l);}\
{ List l;  hteg_list(&l);}\
if ((I)&b100) {Xdimen x; hteg_xdimen_node(&x);} else HTEG_REF(xdimen_kind)
	/*:505*/	/*507:*/
	#line 10372 "format.w"

#define HTEG_STREAM(I) \
{ List l; hteg_list(&l); }\
if ((I)&b010) { List l; hteg_param_list(&l); }  else HTEG_REF(param_kind);\
HTEG_REF(stream_kind);
	/*:507*/	/*509:*/
	#line 10388 "format.w"

#define HTEG_REF(K) do{uint8_t n;  n= HTEG8;}  while (false)
	/*:509*/
	#line 11011 "format.w"

	/*525:*/
	#line 11058 "format.w"

static void hteg_content_node(void);
static void hteg_content(uint8_t z);
static void hteg_xdimen_node(Xdimen*x);
static void hteg_list(List*l);
static void hteg_param_list(List*l);
static float32_t hteg_float32(void);
static void hteg_rule_node(void);
static void hteg_hbox_node(void);
static void hteg_vbox_node(void);
static void hteg_glue_node(void);
	/*:525*/
	#line 11012 "format.w"

	/*434:*/
	#line 9393 "format.w"

uint32_t hff_list_pos= 0,hff_list_size= 0;
uint8_t hff_tag;
void hff_hpos(void)
{signed char i,k;
hff_tag= *hpos;
DBGTAG(hff_tag,hpos);
i= hnode_size[hff_tag];
if(i>0){hpos= hpos+i;return;}
else if(i<0)
{k= 1+(i&0x3);i= i>>2;
hpos= hpos-i;
while(k>0)
{hff_hpos();k--;}
hpos++;
return;
}
else if(hff_tag<=TAG(param_kind,5))
	/*436:*/
	#line 9438 "format.w"

switch(INFO(hff_tag)){
case 1:hff_list_pos= hpos-hstart+1;hff_list_size= 0;hpos= hpos+2;return;
case 2:hpos++;hff_list_size= HGET8;hff_list_pos= hpos-hstart+1;hpos= hpos+1+hff_list_size+1+1+1;return;
case 3:hpos++;HGET16(hff_list_size);hff_list_pos= hpos-hstart+1;hpos= hpos+1+hff_list_size+1+2+1;return;
case 4:hpos++;HGET24(hff_list_size);hff_list_pos= hpos-hstart+1;hpos= hpos+1+hff_list_size+1+3+1;return;
case 5:hpos++;HGET32(hff_list_size);hff_list_pos= hpos-hstart+1;hpos= hpos+1+hff_list_size+1+4+1;return;
}
	/*:436*/
	#line 9411 "format.w"

TAGERR(hff_tag);
}
	/*:434*/	/*465:*/
	#line 9849 "format.w"

float32_t hteg_float32(void)
{union{float32_t d;uint32_t bits;}u;
HTEG32(u.bits);
return u.d;
}
	/*:465*/	/*503:*/
	#line 10287 "format.w"

void hteg_size_boundary(Info info)
{uint32_t n;
if(info<2)return;
n= HTEG8;
if(n-1!=0x100-info)QUIT("List size boundary byte 0x%x does not match info value %d at "SIZE_F,
n,info,hpos-hstart);
}

uint32_t hteg_list_size(Info info)
{uint32_t n;
if(info==1)return 0;
else if(info==2)n= HTEG8;
else if(info==3)HTEG16(n);
else if(info==4)HTEG24(n);
else if(info==5)HTEG32(n);
else QUIT("List info %d must be 1, 2, 3, 4, or 5",info);
return n;
}

void hteg_list(List*l)
{	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 10308 "format.w"

if(KIND(z)!=list_kind&&KIND(z)!=text_kind&&KIND(z)!=param_kind)
QUIT("List expected at 0x%x",(uint32_t)(hpos-hstart));
else
{uint32_t s;
l->k= KIND(z);
l->s= hteg_list_size(INFO(z));
hteg_size_boundary(INFO(z));
hpos= hpos-l->s;
l->p= hpos-hstart;
hteg_size_boundary(INFO(z));
s= hteg_list_size(INFO(z));
if(s!=l->s)QUIT("List sizes at "SIZE_F" and 0x%x do not match 0x%x != 0x%x",
hpos-hstart,node_pos-1,s,l->s);
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 10322 "format.w"

}
}

void hteg_param_list(List*l)
{if(KIND(*(hpos-1))!=param_kind)return;
hteg_list(l);
}


	/*:503*/
	#line 11013 "format.w"

	/*460:*/
	#line 9782 "format.w"

static void hteg_content_section(void)
{hget_section(2);
hpos= hend;
while(hpos>hstart)
hteg_content_node();
}
	/*:460*/	/*461:*/
	#line 9801 "format.w"

static void hteg_content_node(void)
{	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 9803 "format.w"

hteg_content(z);
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 9805 "format.w"

}

static void hteg_content(uint8_t z)
{switch(z)
{
	/*470:*/
	#line 9909 "format.w"

case TAG(glyph_kind,1):{Glyph g;HTEG_GLYPH(1,g);}break;
case TAG(glyph_kind,2):{Glyph g;HTEG_GLYPH(2,g);}break;
case TAG(glyph_kind,3):{Glyph g;HTEG_GLYPH(3,g);}break;
case TAG(glyph_kind,4):{Glyph g;HTEG_GLYPH(4,g);}break;
	/*:470*/	/*472:*/
	#line 9925 "format.w"

case TAG(penalty_kind,1):{int32_t p;HTEG_PENALTY(1,p);}break;
case TAG(penalty_kind,2):{int32_t p;HTEG_PENALTY(2,p);}break;
	/*:472*/	/*474:*/
	#line 9937 "format.w"

case TAG(kern_kind,b010):{Xdimen x;HTEG_KERN(b010,x);}break;
case TAG(kern_kind,b011):{Xdimen x;HTEG_KERN(b011,x);}break;
case TAG(kern_kind,b110):{Xdimen x;HTEG_KERN(b110,x);}break;
case TAG(kern_kind,b111):{Xdimen x;HTEG_KERN(b111,x);}break;
	/*:474*/	/*475:*/
	#line 9946 "format.w"

case TAG(language_kind,1):
case TAG(language_kind,2):
case TAG(language_kind,3):
case TAG(language_kind,4):
case TAG(language_kind,5):
case TAG(language_kind,6):
case TAG(language_kind,7):break;
	/*:475*/	/*477:*/
	#line 9965 "format.w"

case TAG(rule_kind,b011):{Rule r;HTEG_RULE(b011,r);}break;
case TAG(rule_kind,b101):{Rule r;HTEG_RULE(b101,r);}break;
case TAG(rule_kind,b001):{Rule r;HTEG_RULE(b001,r);}break;
case TAG(rule_kind,b110):{Rule r;HTEG_RULE(b110,r);}break;
case TAG(rule_kind,b111):{Rule r;HTEG_RULE(b111,r);}break;
	/*:477*/	/*480:*/
	#line 9992 "format.w"

case TAG(glue_kind,b001):{Glue g;HTEG_GLUE(b001,g);}break;
case TAG(glue_kind,b010):{Glue g;HTEG_GLUE(b010,g);}break;
case TAG(glue_kind,b011):{Glue g;HTEG_GLUE(b011,g);}break;
case TAG(glue_kind,b100):{Glue g;HTEG_GLUE(b100,g);}break;
case TAG(glue_kind,b101):{Glue g;HTEG_GLUE(b101,g);}break;
case TAG(glue_kind,b110):{Glue g;HTEG_GLUE(b110,g);}break;
case TAG(glue_kind,b111):{Glue g;HTEG_GLUE(b111,g);}break;
	/*:480*/	/*483:*/
	#line 10025 "format.w"

case TAG(hbox_kind,b000):{Box b;HTEG_BOX(b000,b);}break;
case TAG(hbox_kind,b001):{Box b;HTEG_BOX(b001,b);}break;
case TAG(hbox_kind,b010):{Box b;HTEG_BOX(b010,b);}break;
case TAG(hbox_kind,b011):{Box b;HTEG_BOX(b011,b);}break;
case TAG(hbox_kind,b100):{Box b;HTEG_BOX(b100,b);}break;
case TAG(hbox_kind,b101):{Box b;HTEG_BOX(b101,b);}break;
case TAG(hbox_kind,b110):{Box b;HTEG_BOX(b110,b);}break;
case TAG(hbox_kind,b111):{Box b;HTEG_BOX(b111,b);}break;
case TAG(vbox_kind,b000):{Box b;HTEG_BOX(b000,b);}break;
case TAG(vbox_kind,b001):{Box b;HTEG_BOX(b001,b);}break;
case TAG(vbox_kind,b010):{Box b;HTEG_BOX(b010,b);}break;
case TAG(vbox_kind,b011):{Box b;HTEG_BOX(b011,b);}break;
case TAG(vbox_kind,b100):{Box b;HTEG_BOX(b100,b);}break;
case TAG(vbox_kind,b101):{Box b;HTEG_BOX(b101,b);}break;
case TAG(vbox_kind,b110):{Box b;HTEG_BOX(b110,b);}break;
case TAG(vbox_kind,b111):{Box b;HTEG_BOX(b111,b);}break;
	/*:483*/	/*486:*/
	#line 10085 "format.w"

case TAG(hset_kind,b000):HTEG_SET(b000);break;
case TAG(hset_kind,b001):HTEG_SET(b001);break;
case TAG(hset_kind,b010):HTEG_SET(b010);break;
case TAG(hset_kind,b011):HTEG_SET(b011);break;
case TAG(hset_kind,b100):HTEG_SET(b100);break;
case TAG(hset_kind,b101):HTEG_SET(b101);break;
case TAG(hset_kind,b110):HTEG_SET(b110);break;
case TAG(hset_kind,b111):HTEG_SET(b111);break;

case TAG(vset_kind,b000):HTEG_SET(b000);break;
case TAG(vset_kind,b001):HTEG_SET(b001);break;
case TAG(vset_kind,b010):HTEG_SET(b010);break;
case TAG(vset_kind,b011):HTEG_SET(b011);break;
case TAG(vset_kind,b100):HTEG_SET(b100);break;
case TAG(vset_kind,b101):HTEG_SET(b101);break;
case TAG(vset_kind,b110):HTEG_SET(b110);break;
case TAG(vset_kind,b111):HTEG_SET(b111);break;

case TAG(hpack_kind,b000):HTEG_PACK(hpack_kind,b000);break;
case TAG(hpack_kind,b001):HTEG_PACK(hpack_kind,b001);break;
case TAG(hpack_kind,b010):HTEG_PACK(hpack_kind,b010);break;
case TAG(hpack_kind,b011):HTEG_PACK(hpack_kind,b011);break;
case TAG(hpack_kind,b100):HTEG_PACK(hpack_kind,b100);break;
case TAG(hpack_kind,b101):HTEG_PACK(hpack_kind,b101);break;
case TAG(hpack_kind,b110):HTEG_PACK(hpack_kind,b110);break;
case TAG(hpack_kind,b111):HTEG_PACK(hpack_kind,b111);break;

case TAG(vpack_kind,b000):HTEG_PACK(vpack_kind,b000);break;
case TAG(vpack_kind,b001):HTEG_PACK(vpack_kind,b001);break;
case TAG(vpack_kind,b010):HTEG_PACK(vpack_kind,b010);break;
case TAG(vpack_kind,b011):HTEG_PACK(vpack_kind,b011);break;
case TAG(vpack_kind,b100):HTEG_PACK(vpack_kind,b100);break;
case TAG(vpack_kind,b101):HTEG_PACK(vpack_kind,b101);break;
case TAG(vpack_kind,b110):HTEG_PACK(vpack_kind,b110);break;
case TAG(vpack_kind,b111):HTEG_PACK(vpack_kind,b111);break;
	/*:486*/	/*488:*/
	#line 10134 "format.w"

case TAG(leaders_kind,1):HTEG_LEADERS(1);break;
case TAG(leaders_kind,2):HTEG_LEADERS(2);break;
case TAG(leaders_kind,3):HTEG_LEADERS(3);break;
case TAG(leaders_kind,b100|1):HTEG_LEADERS(b100|1);break;
case TAG(leaders_kind,b100|2):HTEG_LEADERS(b100|2);break;
case TAG(leaders_kind,b100|3):HTEG_LEADERS(b100|3);break;
	/*:488*/	/*490:*/
	#line 10154 "format.w"

case TAG(baseline_kind,b001):{Baseline b;HTEG_BASELINE(b001,b);}break;
case TAG(baseline_kind,b010):{Baseline b;HTEG_BASELINE(b010,b);}break;
case TAG(baseline_kind,b011):{Baseline b;HTEG_BASELINE(b011,b);}break;
case TAG(baseline_kind,b100):{Baseline b;HTEG_BASELINE(b100,b);}break;
case TAG(baseline_kind,b101):{Baseline b;HTEG_BASELINE(b101,b);}break;
case TAG(baseline_kind,b110):{Baseline b;HTEG_BASELINE(b110,b);}break;
case TAG(baseline_kind,b111):{Baseline b;HTEG_BASELINE(b111,b);}break;
	/*:490*/	/*492:*/
	#line 10172 "format.w"

case TAG(ligature_kind,1):{Lig l;HTEG_LIG(1,l);}break;
case TAG(ligature_kind,2):{Lig l;HTEG_LIG(2,l);}break;
case TAG(ligature_kind,3):{Lig l;HTEG_LIG(3,l);}break;
case TAG(ligature_kind,4):{Lig l;HTEG_LIG(4,l);}break;
case TAG(ligature_kind,5):{Lig l;HTEG_LIG(5,l);}break;
case TAG(ligature_kind,6):{Lig l;HTEG_LIG(6,l);}break;
case TAG(ligature_kind,7):{Lig l;HTEG_LIG(7,l);}break;
	/*:492*/	/*494:*/
	#line 10191 "format.w"

case TAG(disc_kind,b001):{Disc h;HTEG_DISC(b001,h);}break;
case TAG(disc_kind,b010):{Disc h;HTEG_DISC(b010,h);}break;
case TAG(disc_kind,b011):{Disc h;HTEG_DISC(b011,h);}break;
case TAG(disc_kind,b100):{Disc h;HTEG_DISC(b100,h);}break;
case TAG(disc_kind,b101):{Disc h;HTEG_DISC(b101,h);}break;
case TAG(disc_kind,b110):{Disc h;HTEG_DISC(b110,h);}break;
case TAG(disc_kind,b111):{Disc h;HTEG_DISC(b111,h);}break;
	/*:494*/	/*496:*/
	#line 10212 "format.w"

case TAG(par_kind,b000):HTEG_PAR(b000);break;
case TAG(par_kind,b010):HTEG_PAR(b010);break;
case TAG(par_kind,b100):HTEG_PAR(b100);break;
case TAG(par_kind,b110):HTEG_PAR(b110);break;
	/*:496*/	/*498:*/
	#line 10230 "format.w"

case TAG(math_kind,b000):HTEG_MATH(b000);break;
case TAG(math_kind,b001):HTEG_MATH(b001);break;
case TAG(math_kind,b010):HTEG_MATH(b010);break;
case TAG(math_kind,b100):HTEG_MATH(b100);break;
case TAG(math_kind,b101):HTEG_MATH(b101);break;
case TAG(math_kind,b110):HTEG_MATH(b110);break;
case TAG(math_kind,b011):
case TAG(math_kind,b111):break;
	/*:498*/	/*500:*/
	#line 10258 "format.w"


case TAG(image_kind,b001):HTEG_IMAGE(b001);break;
case TAG(image_kind,b010):HTEG_IMAGE(b010);break;
case TAG(image_kind,b011):HTEG_IMAGE(b011);break;
case TAG(image_kind,b100):HTEG_IMAGE(b100);break;
case TAG(image_kind,b101):HTEG_IMAGE(b101);break;
case TAG(image_kind,b110):HTEG_IMAGE(b110);break;
case TAG(image_kind,b111):HTEG_IMAGE(b111);break;
	/*:500*/	/*502:*/
	#line 10276 "format.w"

case TAG(link_kind,b000):HTEG_LINK(b000);break;
case TAG(link_kind,b001):HTEG_LINK(b001);break;
case TAG(link_kind,b010):HTEG_LINK(b010);break;
case TAG(link_kind,b011):HTEG_LINK(b011);break;
	/*:502*/	/*504:*/
	#line 10336 "format.w"

case TAG(adjust_kind,b001):{List l;hteg_list(&l);}break;
	/*:504*/	/*506:*/
	#line 10349 "format.w"

case TAG(table_kind,b000):HTEG_TABLE(b000);break;
case TAG(table_kind,b001):HTEG_TABLE(b001);break;
case TAG(table_kind,b010):HTEG_TABLE(b010);break;
case TAG(table_kind,b011):HTEG_TABLE(b011);break;
case TAG(table_kind,b100):HTEG_TABLE(b100);break;
case TAG(table_kind,b101):HTEG_TABLE(b101);break;
case TAG(table_kind,b110):HTEG_TABLE(b110);break;
case TAG(table_kind,b111):HTEG_TABLE(b111);break;

case TAG(item_kind,b000):{List l;hteg_list(&l);}break;
case TAG(item_kind,b001):hteg_content_node();break;
case TAG(item_kind,b010):hteg_content_node();break;
case TAG(item_kind,b011):hteg_content_node();break;
case TAG(item_kind,b100):hteg_content_node();break;
case TAG(item_kind,b101):hteg_content_node();break;
case TAG(item_kind,b110):hteg_content_node();break;
case TAG(item_kind,b111):hteg_content_node();{uint8_t n;n= HTEG8;}break;
	/*:506*/	/*508:*/
	#line 10379 "format.w"

case TAG(stream_kind,b000):HTEG_STREAM(b000);break;
case TAG(stream_kind,b010):HTEG_STREAM(b010);break;
	/*:508*/	/*510:*/
	#line 10392 "format.w"

case TAG(penalty_kind,0):HTEG_REF(penalty_kind);break;
case TAG(kern_kind,b000):HTEG_REF(dimen_kind);break;
case TAG(kern_kind,b100):HTEG_REF(dimen_kind);break;
case TAG(kern_kind,b001):HTEG_REF(xdimen_kind);break;
case TAG(kern_kind,b101):HTEG_REF(xdimen_kind);break;
case TAG(ligature_kind,0):HTEG_REF(ligature_kind);break;
case TAG(disc_kind,0):HTEG_REF(disc_kind);break;
case TAG(glue_kind,0):HTEG_REF(glue_kind);break;
case TAG(language_kind,0):HTEG_REF(language_kind);break;
case TAG(rule_kind,0):HTEG_REF(rule_kind);break;
case TAG(image_kind,0):HTEG_REF(image_kind);break;
case TAG(leaders_kind,0):HTEG_REF(leaders_kind);break;
case TAG(baseline_kind,0):HTEG_REF(baseline_kind);break;
	/*:510*/
	#line 9811 "format.w"

default:
TAGERR(z);
break;
}
}
	/*:461*/	/*467:*/
	#line 9867 "format.w"

static void hteg_xdimen_node(Xdimen*x)
{	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 9869 "format.w"

switch(z)
{
#if 0

case TAG(xdimen_kind,b000):
{uint8_t n;n= HTEG8;}break;
#endif
case TAG(xdimen_kind,b001):HTEG_XDIMEN(b001,*x);break;
case TAG(xdimen_kind,b010):HTEG_XDIMEN(b010,*x);break;
case TAG(xdimen_kind,b011):HTEG_XDIMEN(b011,*x);break;
case TAG(xdimen_kind,b100):HTEG_XDIMEN(b100,*x);break;
case TAG(xdimen_kind,b101):HTEG_XDIMEN(b101,*x);break;
case TAG(xdimen_kind,b110):HTEG_XDIMEN(b110,*x);break;
case TAG(xdimen_kind,b111):HTEG_XDIMEN(b111,*x);break;
default:
QUIT("Extent expected at 0x%x got %s",node_pos,NAME(z));break;
}
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 9887 "format.w"

}
	/*:467*/	/*478:*/
	#line 9973 "format.w"

static void hteg_rule_node(void)
{	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 9975 "format.w"

if(KIND(z)==rule_kind){Rule r;HTEG_RULE(INFO(z),r);}
else
QUIT("Rule expected at 0x%x got %s",node_pos,NAME(z));
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 9979 "format.w"

}
	/*:478*/	/*481:*/
	#line 10002 "format.w"

static void hteg_glue_node(void)
{	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 10004 "format.w"

if(INFO(z)==b000)HTEG_REF(glue_kind);
else
{Glue g;HTEG_GLUE(INFO(z),g);}
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 10008 "format.w"

}
	/*:481*/	/*484:*/
	#line 10044 "format.w"

static void hteg_hbox_node(void)
{Box b;
	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 10047 "format.w"

if(KIND(z)!=hbox_kind)QUIT("Hbox expected at 0x%x got %s",node_pos,NAME(z));
HTEG_BOX(INFO(z),b);
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 10050 "format.w"

}

static void hteg_vbox_node(void)
{Box b;
	/*462:*/
	#line 9821 "format.w"

uint8_t a,z;
uint32_t node_pos= hpos-hstart;
if(hpos<=hstart)return;
HTEGTAG(z);
	/*:462*/
	#line 10055 "format.w"

if(KIND(z)!=vbox_kind)QUIT("Vbox expected at 0x%x got %s",node_pos,NAME(z));
HTEG_BOX(INFO(z),b);
	/*463:*/
	#line 9828 "format.w"

HTEGTAG(a);
if(a!=z)QUIT("Tag mismatch [%s,%d]!=[%s,%d] at "SIZE_F" to 0x%x\n",NAME(a),INFO(a),NAME(z),INFO(z),
hpos-hstart,node_pos-1);
	/*:463*/
	#line 10058 "format.w"

}
	/*:484*/
	#line 11014 "format.w"


#define SKIP
#define DESCRIPTION "\n This program tests parsing a binary HINT file in reverse direction.\n"

int main(int argc,char*argv[])
{	/*420:*/
	#line 9111 "format.w"

char*prog_name;
char*in_ext;
char*out_ext;
int option_log= false;
#ifndef SKIP
char*file_name= NULL;
int file_name_length= 0;
#endif
	/*:420*/
	#line 11020 "format.w"

in_ext= ".hnt";
out_ext= ".bak";

	/*421:*/
	#line 9127 "format.w"

debugflags= DBGBASIC;
prog_name= argv[0];
if(argc<2)
{fprintf(stderr,
"%s: no input file given\n"
"Try '%s --help' for more information\n",prog_name,prog_name);
exit(1);
}
argv++;
while(*argv!=NULL)
{if((*argv)[0]=='-')
{char option= (*argv)[1];
switch(option)
{case'-':
if(strcmp(*argv,"--version")==0)
{fprintf(stderr,"%s version "HINT_VERSION_STRING"\n",prog_name);
exit(0);
}
else if(strcmp(*argv,"--help")==0)
{	/*417:*/
	#line 9018 "format.w"

fprintf(stdout,
"Usage: %s [OPTION]... FILENAME%s\n",prog_name,in_ext);
fprintf(stdout,DESCRIPTION);
fprintf(stdout,
"\nOptions:\n"
"\t --help \t display this message\n"
"\t --version\t display the HINT version\n"
"\t -l     \t redirect stderr to a log file\n"
#if defined (STRETCH) || defined (SHRINK)
"\t -o FILE\t specify an output file name\n"
#endif
#if defined (STRETCH)
"\t -a     \t write auxiliary files\n"
"\t -g     \t do not use localized names (implies -a)\n"
"\t -f     \t force overwriting existing auxiliary files\n"
"\t -u     \t enable writing utf8 character codes\n"
"\t -x     \t enable writing hexadecimal character codes\n"
#elif defined (SHRINK)
"\t -a     \t use only localized names\n"
"\t -g     \t do not use localized names\n"
"\t -c     \t enable compression\n"
#endif
);
#ifdef DEBUG
fprintf(stdout,"\t -d XXXX \t set debug flag to hexadecimal value XXXX.\n"
"\t\t\t OR together these values:\n");
fprintf(stdout,"\t\t\t XX=%03X   basic debugging\n",DBGBASIC);
fprintf(stdout,"\t\t\t XX=%03X   tag debugging\n",DBGTAGS);
fprintf(stdout,"\t\t\t XX=%03X   node debugging\n",DBGNODE);
fprintf(stdout,"\t\t\t XX=%03X   definition debugging\n",DBGDEF);
fprintf(stdout,"\t\t\t XX=%03X   directory debugging\n",DBGDIR);
fprintf(stdout,"\t\t\t XX=%03X   range debugging\n",DBGRANGE);
fprintf(stdout,"\t\t\t XX=%03X   float debugging\n",DBGFLOAT);
fprintf(stdout,"\t\t\t XX=%03X   compression debugging\n",DBGCOMPRESS);
fprintf(stdout,"\t\t\t XX=%03X   buffer debugging\n",DBGBUFFER);
fprintf(stdout,"\t\t\t XX=%03X   flex debugging\n",DBGFLEX);
fprintf(stdout,"\t\t\t XX=%03X   bison debugging\n",DBGBISON);
fprintf(stdout,"\t\t\t XX=%03X   TeX debugging\n",DBGTEX);
fprintf(stdout,"\t\t\t XX=%03X   Page debugging\n",DBGPAGE);
fprintf(stdout,"\t\t\t XX=%03X   Font debugging\n",DBGFONT);
fprintf(stdout,"\t\t\t XX=%03X   Render debugging\n",DBGRENDER);
fprintf(stdout,"\t\t\t XX=%03X   Label debugging\n",DBGLABEL);
#endif
	/*:417*/
	#line 9147 "format.w"

fprintf(stdout,"\nFor further information and reporting bugs see https://hint.userweb.mwn.de/\n");
exit(0);
}
case'l':option_log= true;break;
#if defined (STRETCH) || defined (SHRINK)
case'o':argv++;
file_name_length= (int)strlen(*argv);
ALLOCATE(file_name,file_name_length+6,char);
strcpy(file_name,*argv);break;
case'g':option_global= option_aux= true;break;
case'a':option_aux= true;break;
#endif
#if defined (STRETCH)
case'u':option_utf8= true;break;
case'x':option_hex= true;break;
case'f':option_force= true;break;
#elif defined (SHRINK)
case'c':option_compress= true;break;
#endif
case'd':
argv++;if(*argv==NULL)
{fprintf(stderr,
"%s: option -d expects an argument\n"
"Try '%s --help' for more information\n",prog_name,prog_name);
exit(1);
}
debugflags= strtol(*argv,NULL,16);
break;
default:
{fprintf(stderr,
"%s: unrecognized option '%s'\n"
"Try '%s --help' for more information\n",prog_name,*argv,prog_name);
exit(1);
}
}
}
else
{int path_length= (int)strlen(*argv);
int ext_length= (int)strlen(in_ext);
ALLOCATE(hin_name,path_length+ext_length+1,char);
strcpy(hin_name,*argv);
if(path_length<ext_length
||strncmp(hin_name+path_length-ext_length,in_ext,ext_length)!=0)
{strcat(hin_name,in_ext);
path_length+= ext_length;
}
stem_length= path_length-ext_length;
ALLOCATE(stem_name,stem_length+6,char);
strncpy(stem_name,hin_name,stem_length);
stem_name[stem_length]= 0;
if(*(argv+1)!=NULL)
{fprintf(stderr,
"%s: extra argument after input file name:  '%s'\n"
"Try '%s --help' for more information\n",prog_name,*(argv+1),prog_name);
exit(1);
}
}
argv++;
}
if(hin_name==NULL)
{fprintf(stderr,
"%s: missing input file name\n"
"Try '%s --help' for more information\n",prog_name,prog_name);
exit(1);
}
	/*:421*/
	#line 11024 "format.w"

	/*423:*/
	#line 9232 "format.w"

if(option_log)
{
strcat(stem_name,".log");
hlog= freopen(stem_name,"w",stderr);
if(hlog==NULL)
{fprintf(stderr,"Unable to open logfile %s",stem_name);
hlog= stderr;
}
stem_name[stem_length]= 0;
}
else
hlog= stderr;
	/*:423*/
	#line 11025 "format.w"

if(!hget_map())QUIT("Unable to map the input file");
hpos= hstart= hin_addr;
hend= hstart+hin_size;
hget_banner();
if(!hcheck_banner("hint"))QUIT("Invalid banner");
hget_directory();
DBG(DBGBASIC,"Skipping Content Section\n");
hteg_content_section();
DBG(DBGBASIC,"Fast forward Content Section\n");
hpos= hstart;
while(hpos<hend)
{hff_hpos();
if(KIND(*(hpos-1))==par_kind&&KIND(hff_tag)==list_kind&&hff_list_size>0)
{uint8_t*p= hpos,*q;
DBG(DBGTAGS,"Fast forward list at 0x%x, size %d",hff_list_pos,hff_list_size);
hpos= hstart+hff_list_pos;
q= hpos+hff_list_size;
while(hpos<q)
hff_hpos();
hpos= p;
}
}
hget_unmap();
	/*429:*/
	#line 9292 "format.w"

if(hlog!=NULL)fclose(hlog);
if(stem_name!=NULL)free(stem_name);
	/*:429*/
	#line 11049 "format.w"

return 0;
}
	/*:524*/
